<script setup lang="ts">
import { ref } from 'vue';
import type { BaseImage, BaseLink } from '@/types/base';
import { ChevronLgRight } from 'slippers-ui/icons';
import PlayButton from '~/assets/icons/play-button.vue';

interface FeatureCardProps {
  header: string;
  aos?: {
    config: {
      dataAos: string;
      duration: string;
    };
  };
  caseStudies: {
    header: string;
    showcaseImg: BaseImage;
    logoImg: BaseImage;
    description: string;
    link: BaseLink;
  }[];
}

defineProps<FeatureCardProps>();

const modalOpen = ref(false);
const selectedCaseStudy = ref<FeatureCardProps['caseStudies'][0] | null>(null);

const openModal = (caseStudy: FeatureCardProps['caseStudies'][0]) => {
  selectedCaseStudy.value = caseStudy;
  modalOpen.value = true;
};

const closeModal = () => {
  modalOpen.value = false;
  selectedCaseStudy.value = null;
};
</script>
<template>
  <section class="section">
    <SlpContainer class="wrapper">
      <div :data-aos="aos?.config?.dataAos || ''" :data-aos-duration="aos?.config?.duration || ''">
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-32 section__header">
          {{ header }}
        </SlpTypography>
      </div>
      <SlpRow
        class="featured-content"
        :data-aos="aos?.config?.dataAos || ''"
        :data-aos-duration="aos?.config?.duration || ''"
      >
        <SlpColumn v-for="caseStudy in caseStudies" :key="caseStudy.header" class="featured-content__card">
          <a
            v-if="caseStudy.link.config.href"
            :href="caseStudy.link.config.href"
            :data-ga-name="caseStudy.link.config.dataGaName"
            :data-ga-location="caseStudy.link.config.dataGaLocation"
          >
            <div class="featured-content__wrap">
              <NuxtImg
                :src="caseStudy.showcaseImg.config.url"
                :alt="caseStudy.showcaseImg.altText"
                class="featured-content--showcase-img slp-mb-24"
                loading="lazy"
              />
              <SlpTypography tag="h2" variant="heading5-bold" class="slp-mb-32">
                {{ caseStudy.header }}
              </SlpTypography>
              <img
                :src="caseStudy.logoImg.config.url"
                :alt="caseStudy.logoImg.altText"
                class="featured-content--logo-img slp-mb-16"
                loading="lazy"
              />
              <SlpTypography tag="p" variant="body1">
                <div v-html="caseStudy.description"></div>
              </SlpTypography>
              <SlpButton
                variant="tertiary"
                class="featured-content__link"
                :data-ga-name="caseStudy.link.config.dataGaName"
                :data-ga-location="caseStudy.link.config.dataGaLocation"
              >
                <SlpTypography variant="body1-bold">
                  {{ caseStudy.link.text }}
                </SlpTypography>
                <SlpIcon :icon="ChevronLgRight" class="learn-more__icon" variant="product" alt="Chevron Right Icon" />
              </SlpButton>
            </div>
          </a>
          <div v-else>
            <div class="featured-content__wrap" @click="openModal(caseStudy)">
              <img
                :src="caseStudy.showcaseImg.config.url"
                :alt="caseStudy.showcaseImg.altText"
                class="featured-content--showcase-img slp-mb-24"
                loading="lazy"
              />
              <SlpTypography tag="h2" variant="heading5-bold" class="slp-mb-32">
                {{ caseStudy.header }}
              </SlpTypography>
              <img
                :src="caseStudy.logoImg.config.url"
                :alt="caseStudy.logoImg.altText"
                class="featured-content--logo-img slp-mb-16"
                loading="lazy"
              />
              <SlpTypography tag="div" variant="body1">
                <div v-html="caseStudy.description"></div>
              </SlpTypography>
            </div>
            <SlpButton
              variant="tertiary"
              class="featured-content__link"
              :data-ga-name="caseStudy.link.config.dataGaName"
              :data-ga-location="caseStudy.link.config.dataGaLocation"
              @click="openModal(caseStudy)"
            >
              <SlpTypography variant="body1-bold">
                {{ caseStudy.link.text }}
              </SlpTypography>
              <SlpIcon :icon="ChevronLgRight" class="learn-more__icon" variant="product" alt="Chevron Right Icon" />
            </SlpButton>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
    <div
      v-if="modalOpen && selectedCaseStudy?.link.config.videoUrl"
      class="modal__backdrop"
      :aria-hidden="!modalOpen"
      @click.self="closeModal"
    >
      <CommonVideoModal :visible="modalOpen" @close="closeModal">
        <template #body>
          <CommonVideo
            :video-src="selectedCaseStudy.link.config.videoUrl"
            class="video"
            :thumbnail-src="selectedCaseStudy?.link.config.videoThumbnail"
          >
            <template #customPlayButton>
              <div class="vimeo-play-button">
                <PlayButton />
              </div>
            </template>
          </CommonVideo> </template
      ></CommonVideoModal>
    </div>
  </section>
</template>
<style lang="scss" scoped>
.section {
  min-width: 100%;
  min-height: 100%;
  position: relative;
  background: $color-surface-800;

  &::before {
    content: '';
    position: absolute;
    bottom: 0;
    right: 0;
    top: 0;
    left: 0;
    background: url(/public/images/backgrounds/infinity-icon-cropped.svg) right 0/115% no-repeat;

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  &__header {
    position: relative;

    @media (max-width: $breakpoint-md) {
      padding-left: $spacing-16;
    }
  }
}

.wrapper {
  background: $color-surface-800;
  padding-top: $spacing-48;
  padding-bottom: $spacing-48;
}

.featured-content {
  display: flex;
  flex-direction: column;
  padding: $spacing-24 0;

  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    padding: 0 0 $spacing-96 0;
    > *:not(:last-child) {
      margin-right: $spacing-24;
    }
  }

  &__wrap {
    flex-basis: 100%;
  }

  &__card {
    flex: 1;
    color: inherit;
    display: flex;
    border-radius: 4px 4px 4px 4px;
    flex-direction: column;
    align-items: flex-start;
    padding: 40px;
    margin: 0 auto;
    width: 100%;
    isolation: isolate;
    background: linear-gradient(141.57deg, #ffffff 0.86%, rgba(255, 255, 255, 0) 99.96%);
    z-index: 1;
    position: relative;
    cursor: pointer;

    @media (max-width: $breakpoint-md) {
      margin-bottom: $spacing-32;
    }

    &:before {
      position: absolute;
      content: '';
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: linear-gradient(141.56deg, #fff 100%, #fff 100%);
      z-index: -1;
      transition: all 0.3s ease-in-out;
      opacity: 0;
      border-radius: 4px 4px 4px 4px;
    }

    &:hover:before {
      opacity: 1;
      border-radius: 4px 4px 100px 4px;
    }

    > a {
      color: $color-primary-200;
    }
  }

  &__text {
    flex-basis: 100%;
    .icon {
      width: 32px;
      height: 32px;
    }
  }

  &__link {
    color: $color-text-link-100;
    padding-left: 0;
    margin-top: $spacing-24;
    &:hover {
      text-decoration-color: $color-text-link-100;
    }

    &:not(button) {
      display: inline-flex;
      align-items: center;

      .slp-icon {
        transform: translateX(4px);
        transition: transform 0.2s ease-in-out;
      }

      &:hover {
        text-decoration: underline;

        .slp-icon {
          transform: translateX(8px);
        }
      }
    }
  }

  &--showcase-img {
    width: 100%;
  }

  &--logo-img {
    max-height: 24px;
  }
}
.case-studies {
  &__card {
    display: flex;
    position: relative;
    border-radius: 4px;
    padding: $spacing-32;
    flex-direction: column;
    align-items: flex-start;
    isolation: isolate;
    background: $color-surface-50;

    @media (max-width: $breakpoint-md) {
      margin: 0 $spacing-16;
    }

    :deep(strong) {
      font-weight: $font-weight-bold;
    }

    &--showcase-img {
      max-width: 100%;
    }

    &--logo-img {
      max-height: 24px;
      margin-bottom: $spacing-32;
    }
  }
}

.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;
}
.vimeo-play-button {
  position: absolute;
  left: 45%;
  top: 43%;
  background: $color-surface-50;
  transition: 0.15s;
  padding: $spacing-8 $spacing-24;
  color: $color-text-300;
  border-radius: 4px;
  width: 88px;
  height: 56px;
  display: flex;
  justify-content: center;
  align-items: center;
  @media (max-width: $breakpoint-sm) {
    left: 40%;
    top: 38%;
    width: 70px;
    height: 46px;
  }
}

.video:hover {
  .vimeo-play-button {
    background: $color-surface-200;
  }
}
</style>
